<?php

/**
 * inf_administra_alarma actions.
 *
 * @package    contratacion
 * @subpackage inf_administra_alarma
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class inf_administra_alarmaActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'CO_ADMINISTRA_ALARMA','CO_ALARMA', 'CO_ROL','CO_TIPO_ALARMA'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
         'CO_ALARMA' =>
        array(
            'id_alarma' => 'CO_ADMINISTRA_ALARMA'
        ),
        'CO_ROL' =>
        array(
            'id_rol' => 'CO_ADMINISTRA_ALARMA'
        ),
        'CO_TIPO_ALARMA' =>
        array(
            'id_tipo_alarma' => 'CO_ALARMA'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
       'CO_ADMINISTRA_ALARMA' =>
       array(
            'id_administra_alarma' => 'id_administra_alarma',
            'id_alarma' => 'id_alarma',
            'id_rol' => 'id_rol',
            'correo_electronico' => 'correo_electronico',
            'dias_por_vencer' => 'dias_por_vencer',
            'dias_repeticion' => 'dias_repeticion',
        ),
        'CO_ALARMA' =>
        array(
            'id_tipo_alarma' => 'id_tipo_alarma',
            'descripcion' => 'descripcion_alarma',
            'numero' => 'numero'
        ),
        'CO_ROL' =>
        array(
            'descripcion' => 'descripcion_rol'
        ),
        'CO_TIPO_ALARMA' =>
        array(
            'descripcion' => 'tipo_alarma'
        )
        
        
    ); //por cada tabla especificar los campos del select
    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'CO_ADMINISTRA_ALARMA' =>
        array(    
            'id_administra_alarma,a' => array('!=' => array(-1)),
            'id_administra_alarma,b' => array('=' => array('id_administra_alarma')),
            'id_alarma' => array('=' => array('id_alarma')),
            'id_rol' => array('=' => array('id_rol')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        ),
        'CO_ALARMA' => 
        array(
            'id_tipo_alarma' => array('=' => array('id_tipo_alarma')),
        )
        
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(); // filtros de condicion or
    protected $fields_orderBy = array(
        'tipo_alarma','descripcion_alarma','descripcion_rol'
    ); //campos para el ordenamiento de la consulta
//    protected $table_field_obligatory = array('id_debito'); //campos obligatorios de filtro - estan en el request

    /*
     * Variables manejo de log
     */
    //true - consulta de administracion
    protected $is_admin = false;
    //si es servicio para filtro agregar campo
    protected $filtro = 'Consulta de Administracion de Alarmas y Notificaciones';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = false;

    /**
     * Construccion de observacion perzonalizada
     * 
     * Toda variable para tomarla del request con el formato:
     * &request-variable&
     * 
     * false - observacion por defecto
     *
     * @var string 
     */
    protected $observacion_list = false;
    protected $observacion_add = false;
    protected $observacion_update = false;
    protected $observacion_remove = false;

    // Validate
    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateAdd(sfWebRequest $request) {

        //valor por defecto
        $errors = null;



        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }
}
